//  RungeKutta4.cpp
#include "RungeKutta4.h"
RungeKutta4::RungeKutta4(int ndim, double dt){
    n = ndim;
    h = dt;
    yn =  vector<double>(n);
    k1 =  vector<double>(n);
    k2 =  vector<double>(n);
    k3 =  vector<double>(n);
    k4 =  vector<double>(n);
}
void RungeKutta4::advanceStep(RHSFunc rhs, double t, vector<double>& y){
    rhs(t, y, k1);
    for(int i=0;i<n;i++) yn[i] = y[i] + h*k1[i]/2;
    rhs(t+h/2, yn, k2);
    for(int i=0;i<n;i++) yn[i] = y[i] + h*k2[i]/2;
    rhs(t+h/2, yn, k3);
    for(int i=0;i<n;i++) yn[i] = y[i] + h*k3[i];
    rhs(t+h, yn, k4);
    for(int i=0;i<n;i++) y[i] += h*(k1[i] + 2*k2[i] + 2*k3[i] + k4[i])/6;
}
