//  main.cpp of ode (ex07)
#include <iostream>
#include <fstream>

#include "RungeKutta4.h"

void rhs(double tt, vector<double> y, vector<double>& dy){
    dy[0] =  y[1];
    dy[1] = -y[0];
}

int main(int argc, char** argv){
    int ndim = 2;                 // number of equations
    double ttime = 10.0;          // total time
    double dt = 0.1;              // step size
    int npts = (int)(ttime/dt)+1; // number of points
    vector<double> y={1.0, 0.0};  // initial values

    RungeKutta4 rk(ndim, dt);

    std::fstream fd("ax.txt", std::ios::out | std::ios::trunc);
    for(int i=0;i<npts;i++){
        double t = dt*i;
        fd << t << " " << y[0] << " " << y[1] << std::endl;
        rk.advanceStep(rhs, t, y);
    }
    fd.close();
#if defined(_WIN32)
    system("..\\..\\tools\\gc ax.txt ");
#else
    system("../../tools/gc ax.txt ");
#endif
    return 0;
}
