// markov.h
#ifndef __included__markov_h__
#define __included__markov_h__

#include <vector>
#include "RungeKutta4.h"

#define NUM_OF_NA_STATES  9
#define NA_OPEN_STATE 3

using std::vector;

class Markov : public RungeKutta4 {
public:
    void setInitialValues(vector<double>& y);
    void rhs(double t, vector<double> y, vector<double>& dy);
private:
    double a11, a12, a13, a2, a3, a4, a5;
    double b11, b12, b13, b2, b3, b4, b5;
    double vold;
};
#endif
