//  channel.java (ex08)
import java.io.FileWriter;
import java.io.IOException;

public class channel{

    public static void main(String [] args){
        int n = 9;                        // number of equations
        double h = 0.01;                  // step size
        double totalTime  = 50.0;         // total time
        int npts = (int)(totalTime /h)+1; // number of points
        double [] y = {1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};  // initial values
        
        Eqs eq = new Eqs();
        eq.initRK4(n, h);

        try{
            FileWriter fw = new FileWriter("ax.txt");
            for(int i=0;i<npts;i++){
                double t = h*i;
                fw.write(t+" "+ y[0] +" "+ y[3]+" "+ y[6]+" "+ y[7]+" "+ y[8] + "\n");
                eq.advanceStep(t, y);
            }
            fw.close();
        }catch(IOException e){
            System.out.println(e);
        }



        String cmd;
        String OS = System.getProperty("os.name", "generic").toLowerCase();
        if (OS.indexOf("win") >= 0) {
            cmd = "cmd /c ..\\..\\tools\\gc ax.txt";            
        }else{ // mac
            cmd = "..//..//tools//gc ax.txt";
        }
        
        try{
            Process p = Runtime.getRuntime().exec(cmd);
            p.waitFor();
        } catch (Exception e) {}




    }
}
