// Cellpot java
import java.io.FileWriter;
import java.io.IOException;

public class Cellpot{

    public static void main(String [] args){
        int n = 6;                        // number of equations
        double h = 0.05;                  // step size
        double totalTime  = 600.0;         // total time
        int npts = (int)(totalTime /h)+1; // number of points
        double vinit = -63.27;  // initial voltate
        double Iinj  = -2000.0; // current injection(pA)
        double Ton   = 50.0;    // on-time
        double Toff  = 300.0;   // off-time

        double [] y = new double[n];
        double [] vol = new double[npts];
        
        Cell cell = new Cell();
        cell.initRK4(n, h);
        cell.setInitialValues(vinit, y);
        cell.setPulse(Ton, Toff, Iinj);

        try{
            FileWriter fw = new FileWriter("ax.txt");
            for(int i=0;i<npts;i++){
                double t = h*i;
                vol[i] = y[0];
                fw.write(t + " " + y[0] + "\n");
                cell.advanceStep(t, y);
            }
            fw.close();
        }catch(IOException e){
            System.out.println(e);
        }


        String cmd;
        String OS = System.getProperty("os.name", "generic").toLowerCase();
        if (OS.indexOf("win") >= 0) {
            cmd = "cmd /c ..\\..\\tools\\gc ax.txt";            
        }else{ // mac
            cmd = "..//..//tools//gc ax.txt";
        }
        
        try{
            Process p = Runtime.getRuntime().exec(cmd);
            p.waitFor();
        } catch (Exception e) {}

    }
}
