
public class RungeKutta4{
    int n;
    double h;
    double [] yn;   
    double [] k1;   
    double [] k2;   
    double [] k3;   
    double [] k4;   

    public void initRK4(int ndim, double dt){
        n = ndim;
        h = dt;
        yn =  new double[n];
        k1 =  new double[n];
        k2 =  new double[n];
        k3 =  new double[n];
        k4 =  new double[n];
    }

    public  void advanceStep(double t, double [] y){
        rhs(t, y, k1);
        for(int i=0;i<n;i++) yn[i] = y[i] + h*k1[i]/2;
        rhs(t+h/2, yn, k2);
        for(int i=0;i<n;i++) yn[i] = y[i] + h*k2[i]/2;
        rhs(t+h/2, yn, k3);
        for(int i=0;i<n;i++) yn[i] = y[i] + h*k3[i];
        rhs(t+h, yn, k4);
        for(int i=0;i<n;i++) y[i] += h*(k1[i] + 2*k2[i] + 2*k3[i] + k4[i])/6;
    }
    public void rhs(double tt, double [] y, double [] dy){}
}

