% channel.m
function channel()
    dt = 0.01;
    ttime = 50.0;
    npts = int32(ttime/dt) + 1;
    tt = linspace(0, ttime, npts);
    y0 = zeros(1,9);
    y0(1) = 1.0;

    vx  = -1000.0;
    [a11, a12, a13, b11, b12, b13] = deal(0.0);
    [a2, b2, a3, b3, a4, b4, a5, b5] = deal(0.0);

    [t,y] = ode45(@(tt, yy)RHS(tt, yy), tt, y0);
    plot(t,y(:,1), t,y(:,4), t,y(:,7), t,y(:,8),t,y(:,9))

    function dy = RHS(t, y)
        if t<20.0 || t>= 30.0
            v = -100.0;
        else
            v = 0.0;
        end
        if v ~= vx
            a11 = 3.802/(0.1027*exp(-v/17.0) + 0.20*exp(-v/150));
            a12 = 3.802/(0.1027*exp(-v/15.0) + 0.23*exp(-v/150));
            a13 = 3.802/(0.1027*exp(-v/12.0) + 0.25*exp(-v/150));

            b11 = 0.1917*exp(-v/20.3);
            b12 = 0.20*exp(-(v-5)/20.3);
            b13 = 0.22*exp(-(v-10)/20.3);

            a3 = (3.7933e-7)*exp(-v/7.7);
            b3 = 0.0084 + 0.00002*v;

            a2 = 9.178*exp(v/29.68);
            b2 = (a13*a2*a3)/(b13*b3);

            a4 = a2/100;
            b4 = a3;

            a5 = a2/(9.5e4);
            b5 = a3/50;           
            vx = v;
        end

        dy=[-(a11 + b3)*y(1) + b11*y(2) + a3*y(5);
            -(b11 + b3 + a12)*y(2) + a11*y(1) + b12*y(3) + a3*y(6);
            -(b12 + b3 + a13)*y(3) + a12*y(2) + b13*y(4) + a3*y(7);
            -(b13 + a2)*y(4) + a13*y(3) + b2*y(7);
            -(a11 + a3)*y(5) + b11*y(6) + b3*y(1);
            -(b11 + a3 + a12)*y(6) + a11*y(5) + b12*y(7) + b3*y(2);
            -(b12 + a3 + b2 + a4)*y(7) + a12*y(6) + b3*y(3) + a2*y(4) + b4*y(8);
            -(b4 + a5)*y(8) + a4*y(7) + b5*y(9);
            -b5*y(9) + a5*y(8)];    
    end % end of function RHS
end % of main
