# ode.py
import numpy as np
from scipy.integrate import odeint
import matplotlib.pyplot as plt

def rhs(y,t):  # return derivatives of the array y
        return np.array([y[1], -y[0]])

def ode():
    ndim = 2
    ttime = 10.0
    dt = 0.1
    npts = int(ttime/dt)+1
    y0 = np.zeros(ndim)
    y0[0] = 1.0
	
    t = np.linspace(0.0, ttime, npts)
    y = odeint(rhs, y0, t)

    plt.figure()
    plt.plot(t, y[:,0], t, y[:,1])
    plt.xlabel('t')
    plt.ylabel('y')
    plt.show()

if __name__ == '__main__':
    ode()
